// Generated by using Rcpp::compileAttributes() -> do not edit by hand
// Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#include <RcppArmadillo.h>
#include <Rcpp.h>

using namespace Rcpp;

// decentralized_personalized_gd
Rcpp::List decentralized_personalized_gd(std::vector< Rcpp::DataFrame > dfs, Rcpp::Nullable< Rcpp::DataFrame > whole_df, Rcpp::Nullable< Rcpp::NumericMatrix > W, Rcpp::Nullable< Rcpp::NumericVector > w0, std::string label, std::string loss_name, float mu, bool intercept, int batch, float momentum, int nb_iter, float cv_tol, bool random_activations, int nb_history_points, bool store_coef, bool store_obj, bool store_only_last);
RcppExport SEXP _decentralized_decentralized_personalized_gd(SEXP dfsSEXP, SEXP whole_dfSEXP, SEXP WSEXP, SEXP w0SEXP, SEXP labelSEXP, SEXP loss_nameSEXP, SEXP muSEXP, SEXP interceptSEXP, SEXP batchSEXP, SEXP momentumSEXP, SEXP nb_iterSEXP, SEXP cv_tolSEXP, SEXP random_activationsSEXP, SEXP nb_history_pointsSEXP, SEXP store_coefSEXP, SEXP store_objSEXP, SEXP store_only_lastSEXP) {
BEGIN_RCPP
    Rcpp::RObject rcpp_result_gen;
    Rcpp::RNGScope rcpp_rngScope_gen;
    Rcpp::traits::input_parameter< std::vector< Rcpp::DataFrame > >::type dfs(dfsSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::DataFrame > >::type whole_df(whole_dfSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::NumericMatrix > >::type W(WSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::NumericVector > >::type w0(w0SEXP);
    Rcpp::traits::input_parameter< std::string >::type label(labelSEXP);
    Rcpp::traits::input_parameter< std::string >::type loss_name(loss_nameSEXP);
    Rcpp::traits::input_parameter< float >::type mu(muSEXP);
    Rcpp::traits::input_parameter< bool >::type intercept(interceptSEXP);
    Rcpp::traits::input_parameter< int >::type batch(batchSEXP);
    Rcpp::traits::input_parameter< float >::type momentum(momentumSEXP);
    Rcpp::traits::input_parameter< int >::type nb_iter(nb_iterSEXP);
    Rcpp::traits::input_parameter< float >::type cv_tol(cv_tolSEXP);
    Rcpp::traits::input_parameter< bool >::type random_activations(random_activationsSEXP);
    Rcpp::traits::input_parameter< int >::type nb_history_points(nb_history_pointsSEXP);
    Rcpp::traits::input_parameter< bool >::type store_coef(store_coefSEXP);
    Rcpp::traits::input_parameter< bool >::type store_obj(store_objSEXP);
    Rcpp::traits::input_parameter< bool >::type store_only_last(store_only_lastSEXP);
    rcpp_result_gen = Rcpp::wrap(decentralized_personalized_gd(dfs, whole_df, W, w0, label, loss_name, mu, intercept, batch, momentum, nb_iter, cv_tol, random_activations, nb_history_points, store_coef, store_obj, store_only_last));
    return rcpp_result_gen;
END_RCPP
}
// decentralized_sgd
Rcpp::List decentralized_sgd(std::vector< Rcpp::DataFrame > dfs, Rcpp::Nullable< Rcpp::DataFrame > whole_df, Rcpp::Nullable< Rcpp::NumericMatrix > W, Rcpp::Nullable< Rcpp::NumericVector > w0, std::string label, std::string loss_name, bool intercept, int batch, float momentum, float alpha, int nb_iter, float cv_tol, bool random_activations, int nb_history_points, bool store_coef, bool store_obj, bool store_only_last);
RcppExport SEXP _decentralized_decentralized_sgd(SEXP dfsSEXP, SEXP whole_dfSEXP, SEXP WSEXP, SEXP w0SEXP, SEXP labelSEXP, SEXP loss_nameSEXP, SEXP interceptSEXP, SEXP batchSEXP, SEXP momentumSEXP, SEXP alphaSEXP, SEXP nb_iterSEXP, SEXP cv_tolSEXP, SEXP random_activationsSEXP, SEXP nb_history_pointsSEXP, SEXP store_coefSEXP, SEXP store_objSEXP, SEXP store_only_lastSEXP) {
BEGIN_RCPP
    Rcpp::RObject rcpp_result_gen;
    Rcpp::RNGScope rcpp_rngScope_gen;
    Rcpp::traits::input_parameter< std::vector< Rcpp::DataFrame > >::type dfs(dfsSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::DataFrame > >::type whole_df(whole_dfSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::NumericMatrix > >::type W(WSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::NumericVector > >::type w0(w0SEXP);
    Rcpp::traits::input_parameter< std::string >::type label(labelSEXP);
    Rcpp::traits::input_parameter< std::string >::type loss_name(loss_nameSEXP);
    Rcpp::traits::input_parameter< bool >::type intercept(interceptSEXP);
    Rcpp::traits::input_parameter< int >::type batch(batchSEXP);
    Rcpp::traits::input_parameter< float >::type momentum(momentumSEXP);
    Rcpp::traits::input_parameter< float >::type alpha(alphaSEXP);
    Rcpp::traits::input_parameter< int >::type nb_iter(nb_iterSEXP);
    Rcpp::traits::input_parameter< float >::type cv_tol(cv_tolSEXP);
    Rcpp::traits::input_parameter< bool >::type random_activations(random_activationsSEXP);
    Rcpp::traits::input_parameter< int >::type nb_history_points(nb_history_pointsSEXP);
    Rcpp::traits::input_parameter< bool >::type store_coef(store_coefSEXP);
    Rcpp::traits::input_parameter< bool >::type store_obj(store_objSEXP);
    Rcpp::traits::input_parameter< bool >::type store_only_last(store_only_lastSEXP);
    rcpp_result_gen = Rcpp::wrap(decentralized_sgd(dfs, whole_df, W, w0, label, loss_name, intercept, batch, momentum, alpha, nb_iter, cv_tol, random_activations, nb_history_points, store_coef, store_obj, store_only_last));
    return rcpp_result_gen;
END_RCPP
}
// gradient_descent
Rcpp::List gradient_descent(Rcpp::DataFrame df, Rcpp::Nullable< Rcpp::DataFrame > whole_df, std::string label, std::string loss_name, bool intercept, int batch, float momentum, std::string learning_rate_type, Rcpp::Nullable< std::vector< float > > learning_rate_param, int nb_iter, float cv_tol, int nb_history_points, std::string save_to, bool store_history, int id, bool append);
RcppExport SEXP _decentralized_gradient_descent(SEXP dfSEXP, SEXP whole_dfSEXP, SEXP labelSEXP, SEXP loss_nameSEXP, SEXP interceptSEXP, SEXP batchSEXP, SEXP momentumSEXP, SEXP learning_rate_typeSEXP, SEXP learning_rate_paramSEXP, SEXP nb_iterSEXP, SEXP cv_tolSEXP, SEXP nb_history_pointsSEXP, SEXP save_toSEXP, SEXP store_historySEXP, SEXP idSEXP, SEXP appendSEXP) {
BEGIN_RCPP
    Rcpp::RObject rcpp_result_gen;
    Rcpp::RNGScope rcpp_rngScope_gen;
    Rcpp::traits::input_parameter< Rcpp::DataFrame >::type df(dfSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::DataFrame > >::type whole_df(whole_dfSEXP);
    Rcpp::traits::input_parameter< std::string >::type label(labelSEXP);
    Rcpp::traits::input_parameter< std::string >::type loss_name(loss_nameSEXP);
    Rcpp::traits::input_parameter< bool >::type intercept(interceptSEXP);
    Rcpp::traits::input_parameter< int >::type batch(batchSEXP);
    Rcpp::traits::input_parameter< float >::type momentum(momentumSEXP);
    Rcpp::traits::input_parameter< std::string >::type learning_rate_type(learning_rate_typeSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< std::vector< float > > >::type learning_rate_param(learning_rate_paramSEXP);
    Rcpp::traits::input_parameter< int >::type nb_iter(nb_iterSEXP);
    Rcpp::traits::input_parameter< float >::type cv_tol(cv_tolSEXP);
    Rcpp::traits::input_parameter< int >::type nb_history_points(nb_history_pointsSEXP);
    Rcpp::traits::input_parameter< std::string >::type save_to(save_toSEXP);
    Rcpp::traits::input_parameter< bool >::type store_history(store_historySEXP);
    Rcpp::traits::input_parameter< int >::type id(idSEXP);
    Rcpp::traits::input_parameter< bool >::type append(appendSEXP);
    rcpp_result_gen = Rcpp::wrap(gradient_descent(df, whole_df, label, loss_name, intercept, batch, momentum, learning_rate_type, learning_rate_param, nb_iter, cv_tol, nb_history_points, save_to, store_history, id, append));
    return rcpp_result_gen;
END_RCPP
}
// decentralized_gradient_descent
Rcpp::List decentralized_gradient_descent(std::vector< Rcpp::DataFrame > dfs, Rcpp::Nullable< Rcpp::DataFrame > whole_df, Rcpp::Nullable< Rcpp::NumericMatrix > W, Rcpp::Nullable< Rcpp::NumericVector > w0, std::string label, std::string loss_name, bool intercept, int batch, float momentum, std::string learning_rate_type, Rcpp::Nullable< std::vector< float > > learning_rate_param, float decay, int nb_local_iter, int nb_iter, float cv_tol, bool random_activations, int nb_history_points, std::string save_to, bool store_history);
RcppExport SEXP _decentralized_decentralized_gradient_descent(SEXP dfsSEXP, SEXP whole_dfSEXP, SEXP WSEXP, SEXP w0SEXP, SEXP labelSEXP, SEXP loss_nameSEXP, SEXP interceptSEXP, SEXP batchSEXP, SEXP momentumSEXP, SEXP learning_rate_typeSEXP, SEXP learning_rate_paramSEXP, SEXP decaySEXP, SEXP nb_local_iterSEXP, SEXP nb_iterSEXP, SEXP cv_tolSEXP, SEXP random_activationsSEXP, SEXP nb_history_pointsSEXP, SEXP save_toSEXP, SEXP store_historySEXP) {
BEGIN_RCPP
    Rcpp::RObject rcpp_result_gen;
    Rcpp::RNGScope rcpp_rngScope_gen;
    Rcpp::traits::input_parameter< std::vector< Rcpp::DataFrame > >::type dfs(dfsSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::DataFrame > >::type whole_df(whole_dfSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::NumericMatrix > >::type W(WSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::NumericVector > >::type w0(w0SEXP);
    Rcpp::traits::input_parameter< std::string >::type label(labelSEXP);
    Rcpp::traits::input_parameter< std::string >::type loss_name(loss_nameSEXP);
    Rcpp::traits::input_parameter< bool >::type intercept(interceptSEXP);
    Rcpp::traits::input_parameter< int >::type batch(batchSEXP);
    Rcpp::traits::input_parameter< float >::type momentum(momentumSEXP);
    Rcpp::traits::input_parameter< std::string >::type learning_rate_type(learning_rate_typeSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< std::vector< float > > >::type learning_rate_param(learning_rate_paramSEXP);
    Rcpp::traits::input_parameter< float >::type decay(decaySEXP);
    Rcpp::traits::input_parameter< int >::type nb_local_iter(nb_local_iterSEXP);
    Rcpp::traits::input_parameter< int >::type nb_iter(nb_iterSEXP);
    Rcpp::traits::input_parameter< float >::type cv_tol(cv_tolSEXP);
    Rcpp::traits::input_parameter< bool >::type random_activations(random_activationsSEXP);
    Rcpp::traits::input_parameter< int >::type nb_history_points(nb_history_pointsSEXP);
    Rcpp::traits::input_parameter< std::string >::type save_to(save_toSEXP);
    Rcpp::traits::input_parameter< bool >::type store_history(store_historySEXP);
    rcpp_result_gen = Rcpp::wrap(decentralized_gradient_descent(dfs, whole_df, W, w0, label, loss_name, intercept, batch, momentum, learning_rate_type, learning_rate_param, decay, nb_local_iter, nb_iter, cv_tol, random_activations, nb_history_points, save_to, store_history));
    return rcpp_result_gen;
END_RCPP
}
// network_gradient_descent
Rcpp::List network_gradient_descent(Rcpp::DataFrame df, std::string agents_addresses, int port, Rcpp::Nullable< Rcpp::DataFrame > whole_df, Rcpp::Nullable< arma::colvec > collab, Rcpp::Nullable< Rcpp::NumericVector > w0, std::string label, std::string loss_name, bool intercept, int batch, float momentum, std::string learning_rate_type, Rcpp::Nullable< std::vector< float > > learning_rate_param, float decay, int nb_local_iter, int nb_iter, float cv_tol, int nb_history_points, std::string save_to, bool store_history, int id, bool append, bool verbose);
RcppExport SEXP _decentralized_network_gradient_descent(SEXP dfSEXP, SEXP agents_addressesSEXP, SEXP portSEXP, SEXP whole_dfSEXP, SEXP collabSEXP, SEXP w0SEXP, SEXP labelSEXP, SEXP loss_nameSEXP, SEXP interceptSEXP, SEXP batchSEXP, SEXP momentumSEXP, SEXP learning_rate_typeSEXP, SEXP learning_rate_paramSEXP, SEXP decaySEXP, SEXP nb_local_iterSEXP, SEXP nb_iterSEXP, SEXP cv_tolSEXP, SEXP nb_history_pointsSEXP, SEXP save_toSEXP, SEXP store_historySEXP, SEXP idSEXP, SEXP appendSEXP, SEXP verboseSEXP) {
BEGIN_RCPP
    Rcpp::RObject rcpp_result_gen;
    Rcpp::RNGScope rcpp_rngScope_gen;
    Rcpp::traits::input_parameter< Rcpp::DataFrame >::type df(dfSEXP);
    Rcpp::traits::input_parameter< std::string >::type agents_addresses(agents_addressesSEXP);
    Rcpp::traits::input_parameter< int >::type port(portSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::DataFrame > >::type whole_df(whole_dfSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< arma::colvec > >::type collab(collabSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< Rcpp::NumericVector > >::type w0(w0SEXP);
    Rcpp::traits::input_parameter< std::string >::type label(labelSEXP);
    Rcpp::traits::input_parameter< std::string >::type loss_name(loss_nameSEXP);
    Rcpp::traits::input_parameter< bool >::type intercept(interceptSEXP);
    Rcpp::traits::input_parameter< int >::type batch(batchSEXP);
    Rcpp::traits::input_parameter< float >::type momentum(momentumSEXP);
    Rcpp::traits::input_parameter< std::string >::type learning_rate_type(learning_rate_typeSEXP);
    Rcpp::traits::input_parameter< Rcpp::Nullable< std::vector< float > > >::type learning_rate_param(learning_rate_paramSEXP);
    Rcpp::traits::input_parameter< float >::type decay(decaySEXP);
    Rcpp::traits::input_parameter< int >::type nb_local_iter(nb_local_iterSEXP);
    Rcpp::traits::input_parameter< int >::type nb_iter(nb_iterSEXP);
    Rcpp::traits::input_parameter< float >::type cv_tol(cv_tolSEXP);
    Rcpp::traits::input_parameter< int >::type nb_history_points(nb_history_pointsSEXP);
    Rcpp::traits::input_parameter< std::string >::type save_to(save_toSEXP);
    Rcpp::traits::input_parameter< bool >::type store_history(store_historySEXP);
    Rcpp::traits::input_parameter< int >::type id(idSEXP);
    Rcpp::traits::input_parameter< bool >::type append(appendSEXP);
    Rcpp::traits::input_parameter< bool >::type verbose(verboseSEXP);
    rcpp_result_gen = Rcpp::wrap(network_gradient_descent(df, agents_addresses, port, whole_df, collab, w0, label, loss_name, intercept, batch, momentum, learning_rate_type, learning_rate_param, decay, nb_local_iter, nb_iter, cv_tol, nb_history_points, save_to, store_history, id, append, verbose));
    return rcpp_result_gen;
END_RCPP
}

static const R_CallMethodDef CallEntries[] = {
    {"_decentralized_decentralized_personalized_gd", (DL_FUNC) &_decentralized_decentralized_personalized_gd, 17},
    {"_decentralized_decentralized_sgd", (DL_FUNC) &_decentralized_decentralized_sgd, 17},
    {"_decentralized_gradient_descent", (DL_FUNC) &_decentralized_gradient_descent, 16},
    {"_decentralized_decentralized_gradient_descent", (DL_FUNC) &_decentralized_decentralized_gradient_descent, 19},
    {"_decentralized_network_gradient_descent", (DL_FUNC) &_decentralized_network_gradient_descent, 23},
    {NULL, NULL, 0}
};

RcppExport void R_init_decentralized(DllInfo *dll) {
    R_registerRoutines(dll, NULL, CallEntries, NULL, NULL);
    R_useDynamicSymbols(dll, FALSE);
}
